#!/bin/sh

DRIVER=arcsas

echo "arcsas Driver post-Installation begining..."

MACHINE=`uname -m`
KERNEL=`uname -r`
export PATH=/bin:/sbin:/usr/bin:/usr/sbin

if echo ${KERNEL} | grep 'fc21\|el6'>/dev/null 2>/dev/null; then
INITRD=initramfs
else
INITRD=initrd
fi

mkdir /tmp/modules
(cd /tmp/modules; gzip -dc /tmp/arcsas/modules.cgz | cpio -idum) 1>/dev/null 2>&1 || { echo "Fail to extract drivers!"; exit 1; }

for ver in /lib/modules/3*; do
	kver=`basename $ver`
	mod=`(find /lib/modules/$kver/kernel/drivers/scsi -type f -name *.xz | head -1) 2>/dev/null`
	vermagic=`modinfo -F vermagic $mod 2> /dev/null`
	[ "$vermagic" = "" ] && vermagic=`strings $mod | grep vermagic`
	( echo "$vermagic" | grep " 586 " -s -q ) && MACHINE=i586
	( echo "$vermagic" | grep " 686 " -s -q ) && MACHINE=i686
	( echo "$vermagic" | grep " x86_64 " -s -q ) && MACHINE=x86_64

	if [ -d /lib/modules/${kver} -a -d /tmp/modules/${kver} ]; then
		echo "Updating ${kver}..."
		mv /boot/${INITRD}-${kver}.img /boot/${INITRD}-${kver}.img.old && 
		mv /lib/modules/${kver}/kernel/drivers/scsi/mvsas/mvsas.ko.xz /lib/modules/${kver}/kernel/drivers/scsi/mvsas/mvsas.ko.x
		cp /tmp/modules/${kver}/${MACHINE}/${DRIVER}.ko.xz /lib/modules/${kver}/kernel/drivers/scsi/ &&
		/sbin/depmod -a ${kver}

		if [ $? = 1 ]; then
			echo "Postinstall 1 failed! Please reinstall your Linux system."
			exit
		fi

		( grep -s -q scsi_mod /lib/modules/${kver}/modules.dep ) && PRESCSI="--preload scsi_mod"
		( grep -s -q sd_mod /lib/modules/${kver}/modules.dep ) && PRESD="--preload sd_mod"
		( grep -s -q scsi_wait_scan /lib/modules/${kver}/modules.dep ) && WITHWAIT="--with=scsi_wait_scan"
		if [ $INITRD = "initramfs" ]; then
			/usr/bin/dracut --add-drivers ${DRIVER} -f /boot/${INITRD}-${kver}.img ${kver}
                else
			/usr/bin/mkinitrd ${PRESCSI} ${PRESD} --with=${DRIVER} ${WITHWAIT} /boot/${INITRD}-${kver}.img ${kver}
		fi

		if [ $? = 1 ]; then
			echo "Postinstall 2 failed! Please reinstall your Linux system."
			exit
		fi
	fi
done

cd /
rm -fr /tmp/modules
rm -fr /tmp/arcsas

echo "arcsas Driver Installation Step 2 Completed."
